#!/usr/local/bin/perl4

#
# Trival example converts pbm to ... pbm ! Pretty useless but just
# demonstrates what's needed.
#
#sub cvtpbm
#{
#    ($vpix,$hpix,$page) = @_;
#    $name = "/tmp/testpbm.".$page;
#    open(F,">".$name) || die "file $!";
#    $size = $hpix*$vpix >> 3;
#    read (STDIN,$bits,$size);
#    print F "P4\n# Test pbm filter for QFAX/printfax\n";
#    print F $vpix,' ',$hpix,"\n";
#    print F $bits;
#    close F;
#}

#
# And this example __might__ convert the output for a Epson GQ printer.
# As I don't have one of these printers so YMMV.
#

sub cvtpbm
{
    ($vpix,$hpix,$page) = @_;
    $nb = $hpix >> 3;

    while (! open(F,">prt"))
    {
      sleep 1;                              # wait for the printer
    }
    print F "\033\100\033v\0\0\033v\007\0"; # reset, del img 0, define img 0 
    print F pack("vv",$vpix,$hpix);         # image size, little endian
    while ($vpix--)
    {
      read  STDIN,$bits,$nb;      	    # read pipe
      print F $bits;                        # send data to printer      
    }
    print F "\033v\014\0\001\001\014";      # print image
    print F "\033v\0\0";                    # delete image 0
    close F;
}

$page = 0;
while($_ = <STDIN>)
{
  if (/P4/)
  {
    1 while (($_ = <STDIN>) && /^\#/);
    ($vpix,$hpix) = split;
    $page++;
    &cvtpbm ($vpix, $hpix, $page);
  }
  else  { last; }
}
